/** Defines the about dialog for DFrac.
 *
 *
 */

package Control;
import util.*;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.io.*;
import java.awt.event.*;
import java.net.URL;

/** Class that renders the AboutDialog of DFrac */
class ClAboutDialog extends JDialog {

    /** the credits thingie, saved here to stop it on tab change */
    private JComponent moCr = null;

    /** Constructor of the about dialog
     *  @param pParent Parent Frame, needed for a modal dialog
     *  @throws EDFracError if about.png could'nt be found*/
    public ClAboutDialog(Frame pParent) throws EDFracError{

        super(pParent,"About...",true);
        JComponent oDFracAboutPane=null;
        try{
            oDFracAboutPane=makeDFracPane();
        }catch(EDFracError e){}
        getContentPane().add(oDFracAboutPane);

        setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
        setResizable( false );

        pack();
        //set the location to the center of parent
        setLocation((pParent.getSize().width/2)-(getSize().width/2),
            (pParent.getSize().height/2)-(getSize().height/2));
        //shows the dialog
        //show();
        setVisible(true);
    }

    /** make the about DFrac Pane
     *  @throws EDFracError if the logo isn't found  */
    private JComponent makeDFracPane() throws EDFracError{

        //main panel
        JPanel pane = new JPanel(new BorderLayout());
        //panel thats used more than one time
        JPanel pane2 = new JPanel(new BorderLayout());
        JLabel myLabel=null;
        try{
            URL iconLocation = ClDFrac.class.getResource("/res/about0.png");
            Image image = Toolkit.getDefaultToolkit().createImage(iconLocation);
            myLabel=new JLabel(new ImageIcon(image), JLabel.CENTER);
        }catch(Exception e){
            throw new EDFracError("dFrac logo could'nt be found");
        }
        pane2.add(myLabel,BorderLayout.NORTH);

        //Version
        JLabel VerLabel=new JLabel(ClDFracVersion.VersionString(),JLabel.CENTER);
        VerLabel.setBorder(BorderFactory.createEmptyBorder(0,10,10,10));
        pane2.add(VerLabel,BorderLayout.CENTER);

        //add label and version to the north of main panel
        pane.add(pane2,BorderLayout.NORTH);

        //authors
        pane2 = new JPanel(new BorderLayout());
        pane2.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
        JTextArea ta = new JTextArea(ClDFracVersion.AUTHORS);
        ta.setBorder(BorderFactory.createEtchedBorder());
        ta.setEditable( false );
        ta.setFont(new Font("Serif",Font.BOLD,12));
        pane2.add(ta,BorderLayout.NORTH);

        JLabel jl = new JLabel(ClDFracVersion.LICENSE_NOTE,JLabel.CENTER);
        jl.setBorder(BorderFactory.createEmptyBorder(10,0,0,0));
        pane2.add(jl,BorderLayout.CENTER);
        pane2.add(new JLabel(ClDFracVersion.LICENSE_SEE,JLabel.CENTER),
            BorderLayout.SOUTH);

        //add authors and License in the center
        pane.add(pane2,BorderLayout.CENTER);

        //OK button
        JButton myButton = new JButton("close");
        myButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                dispose();
            }
        });

        pane2 = new JPanel(new FlowLayout());
        pane2.setBorder(BorderFactory.createEmptyBorder(0,0,0,5));
        pane2.add(myButton);
        //add OK button to the south
        pane.add(pane2,BorderLayout.SOUTH);

        return pane;
    }
    /** make Changelog Pane
     *  @param pD Dimension to set the size of the ScrollPane */
    private JComponent makeChangelog(Dimension pD){

        String strCl="",line="";
        try {
            BufferedReader f = new BufferedReader(new FileReader("CHANGELOG"));
            while ((line = f.readLine()) != null)
                strCl += line+"\n";
            f.close();
        } catch (IOException ex) { }
        JTextArea jta = new JTextArea(strCl);

        JScrollPane jsp = new JScrollPane(jta);
        jsp.setPreferredSize(pD);

        return jsp;
    }

}
