/** CalcControler: as of now handles all the dirty socket work and stuff....
 *  todo: move all socket specific thingies out of here....
 *
 */

package Control;
import DAL.*;
import util.*;
import net.*;


import java.net.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
//import java.util.concurrent.*;
import java.io.*;

/** Class that defines the Listener for changes */
public class ClCalcControl extends JFrame implements IFracChangedListener,ICalcPerformedListener,
Runnable {
    //public boolean mbRunnin=true;
    private boolean mbCalcing=false;
    //private boolean bNeedsRecalc=false;
    //private boolean bTimeOutAchieved=true;
    private IFrac moFrac;
    private ClDFrac moMain;
    private JTextField moPiecesField;
    private JTextField moTimeoutField;
    private ICalcProvider[] miCalcProviders;
    private JCheckBox[] moUseChechboxes;
    private volatile java.util.List mqWaitingPiecesQueue;
    private volatile java.util.Stack mqReadyPiecesQueue;
    private volatile int mnPiecesWaiting;
    
    //window thingies
    private JTextField mtStatusTime;
    private JTextField mtStatusPending;
    private JTextField mtStatusReady;
    private long mlStarted;
    
    /** creates a new ClCalcControl
     */
    public ClCalcControl(IFrac oFrac,ClDFrac xdf){
        super("Calculation Controller");
        mqReadyPiecesQueue = new java.util.Stack();
        moFrac = oFrac;
        moFrac.setChangeListener(this);
        moMain = xdf;
        
        //create Window:
        setSize(350,600);
        setDefaultCloseOperation(WindowConstants.HIDE_ON_CLOSE);
        
        JPanel pane = new JPanel();
        
        JButton b = new JButton("start");
        b.addActionListener(
        new AbstractAction() {
            public void actionPerformed(ActionEvent e){
                start();
            }
        }
        );
        pane.add(b);
        b=new JButton("stop");
        b.addActionListener(
        new AbstractAction() {
            public void actionPerformed(ActionEvent e){
                stop();
            }
        }
        );
        pane.add(b);
        
        moPiecesField = new JTextField("25");
        moPiecesField.setPreferredSize(new Dimension(30,18));
        moTimeoutField = new JTextField("100");
        moTimeoutField.setPreferredSize(new Dimension(30,18));
        
        pane.add(new JLabel("Pieces:"));
        pane.add(moPiecesField);
        pane.add(new JLabel("Timeout:"));
        pane.add(moTimeoutField);
        
        pane.setPreferredSize(new Dimension(350,40));
        
        getContentPane().add(pane, BorderLayout.NORTH);
        
        
        //Tabbedpane
        ICalcProvider[] aCps = { (new ClThreadedCalcProvider()),(new ClCorbaCalcProvider()),(new ClSocketedCalcProvider()),(new ClSOAPCalcProvider()) };
        this.miCalcProviders = aCps;
        moUseChechboxes = new JCheckBox[aCps.length];
        String[] aNames = {"Threads","Corba","Sockets","SOAP" };
        JPanel ppp=null,pp2=null;
        JTabbedPane jsp = new JTabbedPane();
        
        for (int i=0;i<miCalcProviders.length;i++){
            ppp = new JPanel(new FlowLayout());
            pp2 = new JPanel();
            moUseChechboxes[i] = new JCheckBox("use");
            JLabel numlabel = new JLabel("(0 Servers)");
            ppp.add(moUseChechboxes[i]);
            ppp.add(numlabel);
            pp2.add(ppp,BorderLayout.NORTH);
            pp2.add((JPanel)miCalcProviders[i]);
            jsp.add(aNames[i],pp2);
            miCalcProviders[i].setCalcPerformedListener(this);
            miCalcProviders[i].setServerNumberLabel(numlabel);
        }
        moUseChechboxes[0].setSelected(true);
        ((ClThreadedCalcProvider)miCalcProviders[0]).addServer("localThread");
        
        jsp.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
        jsp.setPreferredSize(new Dimension(350,500));
        getContentPane().add(jsp, BorderLayout.CENTER);
        
        
        //Status Bar
        JPanel statusPane = new JPanel(new GridLayout(1, 3));
        statusPane.setPreferredSize(new Dimension(350,18));
        
        mtStatusTime = new JTextField("ready");
        mtStatusTime.setPreferredSize(new Dimension(100,18));
        mtStatusTime.setEditable(false);
        mtStatusTime.setBorder(BorderFactory.createLoweredBevelBorder());
        statusPane.add(mtStatusTime);
        
        mtStatusPending = new JTextField("n/a pieces pending");
        mtStatusPending.setPreferredSize(new Dimension(100,18));
        mtStatusPending.setEditable(false);
        mtStatusPending.setBorder(BorderFactory.createLoweredBevelBorder());
        statusPane.add(mtStatusPending);
        
        
        mtStatusReady = new JTextField("n/a pieces ready");
        mtStatusReady.setPreferredSize(new Dimension(100,18));
        mtStatusReady.setEditable(false);
        mtStatusReady.setBorder(BorderFactory.createLoweredBevelBorder());
        statusPane.add(mtStatusReady);
        
        getContentPane().add(statusPane, BorderLayout.SOUTH);
        statusPane.setVisible(true);
        new Thread(this).start();
        
        pack();
        setVisible(true);
        repaint();
    }
    
    public boolean isRunning(){ return this.mbCalcing; }
    
    public java.util.Stack getReadyPiecesQueue(){
        return this.mqReadyPiecesQueue;
    }
    
    /** Method which gets called when a fractalChanged event is fired
     *  (inherited from IFracChangedListener)
     */
    public void fractalChanged(){
        DFracLog.log(3,"CalcControl:Fractal changed! recalculating...");
        moMain.setSpinners();
        start();
    }
    // public void itemStateChanged(ItemEvent e){
    
    //}
    public int getTimeout(){
        return (Integer.parseInt(moTimeoutField.getText()));
    }
    public void distributedCalc(){
        start();
    }
    
    public void start(){
        if (this.mbCalcing){
            this.stop();
            try{ Thread.sleep(200); } catch(Exception e){}
        }
        
        DFracLog.log(3,"CalcControl: starting calc...");
        this.mbCalcing=true;
        moFrac.initFracPieces(Integer.parseInt(moPiecesField.getText()));
        IFracPiece[] ifps = moFrac.getFracPieces();
        mnPiecesWaiting=Integer.parseInt(moPiecesField.getText());
        DFracLog.log(4,"CalcControl: starting calc for "+moFrac);
        
        java.util.List l = Arrays.asList(ifps);
        this.mqWaitingPiecesQueue = new LinkedList(l);
        boolean bSome=false;
        for (int i=0;i<miCalcProviders.length;i++){
            if (moUseChechboxes[i].isSelected()){
                this.miCalcProviders[i].begin(this.mqWaitingPiecesQueue);
                DFracLog.log(3,"CalcControl: started controler '"+this.miCalcProviders[i].getName()+"'");
                bSome=true;
            }
        }
        if (!bSome){
            DFracLog.log(1,"CalcControl: no CalcProvider Selected!");
            this.mbCalcing=false;
            return;
        }
        
        this.mlStarted = System.currentTimeMillis();
        this.mtStatusTime.setText("00ms");
        this.mtStatusReady.setText("0 pieces ready");
        if (mqWaitingPiecesQueue!=null)
            this.mtStatusPending.setText(mqWaitingPiecesQueue.size()+" pieces pending");
        synchronized(this){
            notify();
        }
        repaint();
    }
    
    public void kill(){
        stop();
        for (int i=0;i<miCalcProviders.length;i++)
            this.miCalcProviders[i].kill();
    }
    public void stop(){
        this.mqWaitingPiecesQueue=null;
        if (!this.mbCalcing) return;
        this.mbCalcing=false;
        for (int i=0;i<miCalcProviders.length;i++)
            this.miCalcProviders[i].stop();
        
    }
    
    
    public void calcSucceeded(IFracPiece oCallingFracPiece) {
        if (oCallingFracPiece != null){
            if (!oCallingFracPiece.isReady()){
                DFracLog.log(2,"CalcControl:Calc succeeded called but "+oCallingFracPiece+" not ready!");
                if (this.mbCalcing){
                    synchronized(mqWaitingPiecesQueue){
                        if (!this.mqWaitingPiecesQueue.contains(oCallingFracPiece)){
                            DFracLog.log(2,"CalcControl:Calc succeeded: Readding "+oCallingFracPiece);
                            mqWaitingPiecesQueue.add(oCallingFracPiece);
                        }
                    }
                }
            }else{      //ready...
                DFracLog.log(3,"CalcControl: calc succeeded: "+oCallingFracPiece);
                synchronized(mqReadyPiecesQueue){
                    mqReadyPiecesQueue.push(oCallingFracPiece);
                }
                moFrac.setFracPiece(oCallingFracPiece);
                //moMain.repaintCurrentDAL();
                mnPiecesWaiting--;
                if (mnPiecesWaiting==0){
                    stop();
                    updateThingies();
                    DFracLog.log(3,"CalcControl: calc ended, all pieces returned");
                }
            }
        }
        
    }
    
    
    public IFracPiece getNewPiece() {
        if (this.mbCalcing){
            try{
                synchronized(mqWaitingPiecesQueue){
                    return (IFracPiece)mqWaitingPiecesQueue.remove(0);
                }
            }catch(Exception e){ return null; }
        }
        return null;
        
    }
    
    public void run() {
        boolean bStillWorkers;
        try{
            while(true){
                synchronized(this){
                    wait();
                }
                
                while (this.mbCalcing){
                    Thread.sleep(50);
                    bStillWorkers=false;
                    for (int i=0;i<miCalcProviders.length;i++)
                        if (moUseChechboxes[i].isSelected())
                            if (miCalcProviders[i].tick()) bStillWorkers=true;
                    updateThingies();
                    if (!bStillWorkers){
                        DFracLog.log(1,"CalcControl: Mainloop: No more calc Controlers, ending calc...");
                        this.stop();
                    }
                }
            }
        }catch(InterruptedException e){return;}
    }
    private void updateThingies(){
        try{
            this.mtStatusTime.setText(new Long(System.currentTimeMillis()-this.mlStarted).toString()+"ms");
            this.mtStatusReady.setText((Integer.parseInt(moPiecesField.getText())-mnPiecesWaiting)+" pieces ready");
            this.mtStatusPending.setText(mnPiecesWaiting+" pieces pending");
            if (this.mqReadyPiecesQueue.size()>0) this.moMain.forcedRepaintCurrentDAL();
        }catch(NullPointerException npe){
            DFracLog.log(1,"CalcControl: Update: NPE caught...");
        }
    }
    
}
