import java.io.*;
import org.omg.CORBA.ORB;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextExt.*;

import DFracCorba.*;


public class CorbaClient{
    
    private static double[] daten;
    private static int[] intarray;
    
    public CorbaClient(){
        daten = new double[10];
        daten[0] = 80.0; // FracWidth
        daten[1] = 22.0; // FracHeight
        daten[2] = 0.0; // CenterX
        daten[3] = 0.0; // CenterY
        daten[4] = 15.0; // Zoom
        daten[5] = 500.0; // NMax
        daten[6] = 0.0; // FracPiece upper left corner X
        daten[7] = 0.0; // FracPiece upper left corner Y
        daten[8] = 80.0; // FracPiece Width
        daten[9] = 22.0; // FracPiece Height
        intarray = new int[800*600];
    }
    
    public static void main(String args[]) throws IOException {
        CorbaDFracServer oServer;
        CorbaDFracServer dfcserver=null;
	org.omg.CORBA.Object objRef=null;
	NamingContextExt ncRef=null;
        try{
            
            org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args, null);
            
            // get the root naming context
            objRef =
            orb.resolve_initial_references("NameService");
        }catch(Exception e){System.out.println("Error: init orb:"+e.getMessage());}
        try{    
            ncRef = NamingContextExtHelper.narrow(objRef);
            // resolve the Object Reference in Naming
        }catch(Exception e){System.out.println("Error: narrowing nc:"+e.getMessage());}
        try{
	    String name = "DFracCalculator";
            dfcserver = CorbaDFracServerHelper.narrow(ncRef.resolve_str(name));
            
       }catch(Exception e){System.out.println("Error: narrowing dfrac:"+e.getMessage());}
            
	    CorbaClient dfc = new CorbaClient();
            String t=null,version=null;
            
            try{
                version = dfcserver.getVersion();
                } catch (Exception e) {
                System.err.println("Error getting Version:"+e.toString());
            }
                System.out.println("got Version: "+version);
             try{
                t = dfcserver.calculate(dfc.daten);
             } catch (Exception e) {
                System.err.println("Error getting calculate:"+e.toString());
            }
               System.err.println("got data:"+t); 
             try{
                String[] ints = t.split(",");
                for (int i=0;i<ints.length;i++) dfc.intarray[i] = Integer.parseInt(ints[i]);
            } catch (Exception e) {
                System.err.println("Error splitting and setting ints:"+e.toString());
            }
            
            int index=0;
            for(int i=0; i<22;++i){
                for(int j=0; j<80;++j){
                    if(dfc.intarray[index]<10) System.out.print(" ");
                    else if(dfc.intarray[index]<20) System.out.print(".");
                    else if(dfc.intarray[index]<30) System.out.print(".");
                    else if(dfc.intarray[index]<40) System.out.print(":");
                    else if(dfc.intarray[index]<50) System.out.print(":");
                    else if(dfc.intarray[index]<60) System.out.print("+");
                    else if(dfc.intarray[index]<70) System.out.print("+");
                    else if(dfc.intarray[index]<80) System.out.print("x");
                    else if(dfc.intarray[index]<90) System.out.print("x");
                    else if(dfc.intarray[index]<100) System.out.print("#");
                    else System.out.print("#");
                    ++index;
                }
                System.out.print("\n");
            }
        
    }
}
