/** Interface that defines how the Data Abstraction Layer (DAL) represents a
 *  Fractal to the outside world.
 *
 */


package DAL;

import util.*;
import java.util.*;

public interface IFrac {
    int getNMax();
    int getHeight();
    int getWidth();
    double getCenterX();
    double getCenterY();
    double x2FracVal(int nX);
    double y2FracVal(int nY);
    int getZoom();
    void setChangeListener(IFracChangedListener ifcl);
    void setUpdateListener(IFracUpdatedListener iful);
    
    void setNMax(int nmax);
    void setZoom(int nNewZoom)    throws EDFracError;
    void setCenter(double dNewCenterX, double dNewCenterY)    throws EDFracError;
    void setBoundaries(int nWidth, int nHeight) throws EDFracError;
    void changeSelection(int nCenter_x, int nCenter_y, double dZoomfactor)    throws EDFracError;
    
    void initFracPieces(int nPieces);
    void setFracPiece(IFracPiece ifp);
    void calculate() throws EDFracError;
    
    void reset();
    
    IFracPiece[] getFracPieces();
}
