/** Interface that defines how the Data Abstraction Layer (DAL) represents a
 *  Piece of a Fractal to the outside world.
 *
 */


package DAL;

import util.*;

public interface IFracPiece {
    //constants for request/response mode
    public static final byte STATE_PING = 0;
    public static final byte STATE_PONG = 1;
    
    public static final byte STOP = 2;
    public static final byte CALC = 3;
    public static final byte KILL = 4;
    public static final byte CLOSE = 5;
    
    //public static final byte OK = 8;
    //public static final byte Error = 9;
    
    int getX();
    int getY();
    int getHeight();
    int getWidth();
    int getFracWidth();
    int getFracHeight();
    int getZoom();
    int getNMax();
    int getNumber();
    double getFracCenterX();
    double getFracCenterY();
    byte getProgress();
    void update(int num, int width, int height, int x, int y,
    	int zoom, int nMax,int totX,int totY,double centerX,double centerY);
    
    public void run();  //method for the thread version, just calls
    public void calculate();
    public boolean isReady();
    int[] getPoints();
    void setPoints(int[] moarray);
}
