package DFracCorba;

import java.io.*;

import org.omg.CORBA.*;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;



public class DFracCorbaCalculator extends CorbaDFracServerPOA{
    
    private ORB orb;
    
    public static final String VERSION = "0.5";
    
    public String getVersion(){
        
        return VERSION;
    }
    
    
    public void setORB(ORB orb_val) {
        orb = orb_val;
    }
    
    public String calculate(double[] fracpieceData) {
        System.out.println("calculate called, beginning...");
        int nFracWidth = (int)fracpieceData[0];
        int nFracHeight = (int)fracpieceData[1];
        double dCenterX = fracpieceData[2];
        double dCenterY = fracpieceData[3];
        int nZoom = (int)fracpieceData[4];
        int nMax = (int)fracpieceData[5];
        int nFracPieceULCornerX = (int)fracpieceData[6];
        int nFracPieceULCornerY = (int)fracpieceData[7];
        int nFracPieceWidth = (int)fracpieceData[8];
        int nFracPieceHeight = (int)fracpieceData[9];
        int[] fracpieceCalc = new int[nFracPieceWidth*nFracPieceHeight];
        /* ------   insert method code here   ------ */
        calculateFracPiece(
        fracpieceCalc,
        nFracWidth,
        nFracHeight,
        dCenterX,
        dCenterY,
        nZoom,
        nMax,
        nFracPieceULCornerX,
        nFracPieceULCornerY,
        nFracPieceWidth,
        nFracPieceHeight
        );
        /* ------ ---------- end ------------ ------ */
        
        StringBuffer sb = new StringBuffer(fracpieceCalc.length*2);
        int i=0;
        sb.append(fracpieceCalc[i]);
        while (i < (fracpieceCalc.length-1))
            sb.append(","+fracpieceCalc[++i] );
        
        System.out.println("all calculated, returning...");
        return sb.toString();
    }
    
    private void calculateFracPiece(
    int[] fracpieceCalc,
    int nFracWidth,
    int nFracHeight,
    double dCenterX,
    double dCenterY,
    int nZoom,
    int nMax,
    int nFracPieceULCornerX,
    int nFracPieceULCornerY,
    int nFracPieceWidth,
    int nFracPieceHeight ) {
        int index=0, yb, xa;
        double a, b;
        for(yb=0; yb<nFracPieceHeight; ++yb){
            b = ((double)nFracHeight/2-((double)(nFracPieceULCornerY+yb))) / ((double)nZoom) + dCenterY;
            for(xa=0;xa<nFracPieceWidth; ++xa){
                a = (-(double)nFracWidth/2+((double)(nFracPieceULCornerX+xa))) / ((double)nZoom) + dCenterX;
                fracpieceCalc[index++] = mandelcalculation(a,b,nMax);
            }
        }
    }
    
    int mandelcalculation(double a, double b, int nMax){
        double tmp, x=0, y=0;
        int i=0;
        do {
            ++i;
            tmp  = x*x - y*y + a;
            y = 2*x*y + b;
            x = tmp;
        } while (((x*x + y*y) <= 4) && (i < nMax));
        return i;
    }
    
}
