/** Interface for package PL
 *
 */

package PL;
import java.util.*;
import util.*;
import DAL.*;

public interface IPL {
    /** Value for color effect 1 */
    public static final byte COLOREFF0 = 0;
    /** Value for color effect 2 */
    public static final byte COLOREFF1 = 1;
    /** Value for color effect 3 */
    public static final byte COLOREFF2 = 2;
    /** Value for color effect 4 */
    public static final byte COLOREFF3 = 3;
    /** Value for color effect 5 */
    public static final byte COLOREFF4 = 4;
    
    /** If any changes in DAL are made (e.g. new DAL), you can set/change it 
     *  this way, the diagram will be repainted
     * @param oFractal The DAL to use
     */
    void setDALObj( IFrac oFractal);
    
    /** If you want to be informed about any changes in selection, you can get a
     *  callback by offering an ISelChangedListener
     * @param poSelListener Listener for selection-information callbacks
     */
    void setSelChangedListener( ISelChangedListener poSelListener );
    
    /** Change the Color Effect
     */
    void changeColorEffect(byte colEffect);
    
    /** Repaints all the PL's components
     */
    void repaint();
}
