
import org.apache.axis.client.Call;
import org.apache.axis.client.Service;
import javax.xml.namespace.QName;


public class SOAPClient{
    
    private static double[] daten;
    private static int[] intarray;
    
    public SOAPClient(){
        daten = new double[10];
        daten[0] = 80.0; // FracWidth
        daten[1] = 22.0; // FracHeight
        daten[2] = 0.0; // CenterX
        daten[3] = 0.0; // CenterY
        daten[4] = 35.0; // Zoom
        daten[5] = 500.0; // NMax
        daten[6] = 0.0; // FracPiece upper left corner X
        daten[7] = 0.0; // FracPiece upper left corner Y
        daten[8] = 80.0; // FracPiece Width
        daten[9] = 22.0; // FracPiece Height
        intarray = new int[800*600];
    }
    
    public static void main(String args[]){
        SOAPClient dfc=null;
        Call  call=null;
        String endpoint =
            "http://localhost:8080/axis/DFracSOAPCalculator.jws";
        try {
            
            Service  service = new Service();
            call = (Call) service.createCall();
            dfc = new SOAPClient();
        } catch (Exception e) {
            System.err.println("Error creating service:"+e.toString());
        }
        try{
            call.setTargetEndpointAddress( new java.net.URL(endpoint) );
            call.setOperation("calculate");
        } catch (Exception e) {
            System.err.println("Error setting call:"+e.toString());
        }
        String ret="";
        try{
            ret = (String) call.invoke( new Object[] { dfc.daten } );
            System.out.println("Sent Daten, got '" + ret + "'");
            
        } catch (Exception e) {
            System.err.println("Error calling:"+e.toString());
        }
        try{
            String[] ints = ret.split(",");
            for (int i=0;i<ints.length;i++) dfc.intarray[i] = Integer.parseInt(ints[i]);
        } catch (Exception e) {
            System.err.println("Error splitting and setting ints:"+e.toString());
        }
        
        
        
        int index=0;
        for(int i=0; i<22;++i){
            for(int j=0; j<80;++j){
                if(dfc.intarray[index]<10) System.out.print(" ");
                else if(dfc.intarray[index]<20) System.out.print(".");
                else if(dfc.intarray[index]<30) System.out.print(".");
                else if(dfc.intarray[index]<40) System.out.print(":");
                else if(dfc.intarray[index]<50) System.out.print(":");
                else if(dfc.intarray[index]<60) System.out.print("+");
                else if(dfc.intarray[index]<70) System.out.print("+");
                else if(dfc.intarray[index]<80) System.out.print("x");
                else if(dfc.intarray[index]<90) System.out.print("x");
                else if(dfc.intarray[index]<100) System.out.print("#");
                else System.out.print("#");
                ++index;
            }
            System.out.print("\n");
        }
        
    }
}
