/*
 * ClAbstractCalcProvider.java
 *
 * Created on 13. Mai 2004, 14:42
 */

package net;
import Control.*;
import DAL.*;
import util.*;

import java.net.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

/**
 *
 * @author  Vitus
 */
public class ClAbstractCalcProvider extends JPanel implements ICalcProvider{
    
    protected JPanel  moWorkersPane;
    protected volatile Vector mvWorkers;
    protected volatile java.util.List mqWaitingPieces;
    //protected volatile java.util.Stack mqReadyPieces;
    protected ICalcPerformedListener miPerfListener;
    protected String Name;
    protected Class moWorkerSubClass;
    protected JLabel moServerNumberLabel;
    
    
    /** Creates a new instance of ClAbstractCalcProvider */
    public ClAbstractCalcProvider(String name,String WorkerName) {
        super();
        //inits
        mvWorkers = new Vector();
        this.Name = name;
        
        //add button and field
        final JTextField jtf = new JTextField(WorkerName);
        jtf.setPreferredSize(new Dimension(100,20));
        jtf.addActionListener(
        new AbstractAction() {
            public void actionPerformed(ActionEvent e){
                addServer(jtf.getText());
                jtf.setText("");
            }
        }
        );
        JButton b = new JButton("add");
        b.addActionListener(
        new AbstractAction() {
            public void actionPerformed(ActionEvent e){
                addServer(jtf.getText());
                jtf.setText("");
            }
        }
        );
        
        JPanel pane = new JPanel();
        //pane.setPreferredSize(new Dimension(300,40));
        pane.add(jtf);
        pane.add(b);
        this.add(pane, BorderLayout.NORTH);
        
        
        //Worker Panel
        moWorkersPane = new JPanel();
        moWorkersPane.setPreferredSize(new Dimension(340,470));
        //moServerPane.setBorder(BorderFactory.createEmptyBorder(10,5,5,5));
        moWorkersPane.setLayout(new BoxLayout(moWorkersPane , BoxLayout.Y_AXIS));
        this.add(moWorkersPane, BorderLayout.CENTER);
        
        this.setPreferredSize(new Dimension(350,490));
        
        //pack();
        // this.show();
        this.setVisible(true);
        repaint();
        
    }
    
    public void setCalcPerformedListener(ICalcPerformedListener icpl){
        this.miPerfListener = icpl;
    }
    public void setServerNumberLabel(JLabel nl){ this.moServerNumberLabel = nl; }
    
    public void addServer(String server){
        //try and open a connxion to the server...
        try{
            JPanel pl = new JPanel();
            JLabel sl = new JLabel();
            final ClAbstractWorkerThread awt = (ClAbstractWorkerThread)moWorkerSubClass.newInstance();
            
            awt.init(pl,sl,this.Name+"Worker("+mvWorkers.size()+")",this);
            if (!awt.connect(server)){
                DFracLog.log(1,Name+":addServer: Error adding server "+server);
                return;
            }
            sl.setText("[v"+awt.msVersionString+" ready]");
            
            mvWorkers.add(awt);
            
            pl.setPreferredSize(new Dimension(340,30));
            pl.add(new JLabel("("+mvWorkers.size()+") "+server));
            
            pl.add(sl);
            JButton but = new JButton("X");
            //but.setPreferredSize(new Dimension(40,40));
            but.addActionListener(
            new AbstractAction() {
                public void actionPerformed(ActionEvent e){
                    remServer(awt);
                }
            }
            );
            pl.add(but);
            
            moWorkersPane.add(pl);
            awt.start();
            
            //running? if yes, start thread
            if (((ClCalcControl)this.miPerfListener).isRunning()){
                try{ Thread.sleep(50); }catch(Exception e){}
                awt.beginCalcing();
                
            }
            
        }catch(InstantiationException ie){
            DFracLog.log(1,Name+":addServer: Instantiation Exception: "+ie.getCause());
            ie.printStackTrace();
            return;
        }catch(IllegalAccessException ia){
            DFracLog.log(1,Name+":addServer: Illegal Access Exception: "+ia.getMessage());
            return;
        }
        
        DFracLog.log(3,this.Name+":addServer:added and started worker("+(mvWorkers.size()-1)+")");
        this.moServerNumberLabel.setText("("+mvWorkers.size()+" Server(s))");
        repaint();
        
        
    }
    
    public void remServer(ClAbstractWorkerThread awt){
        try{
            awt.end();
            awt.disConnect();
            Thread.sleep(50);
            
        }catch(Exception ex){
            System.out.println(Name+":remServer:disConnect: "+ex.getMessage());
        }
        
        try{
            awt.interrupt();
            mvWorkers.remove(awt);
            moWorkersPane.remove(awt.myPanel);
            moWorkersPane.repaint();
            DFracLog.log(3,Name+":remServer: Worker "+awt.getName()+" removed");
            
        }catch (Exception e){
            DFracLog.log(1,Name+":remServer:interrupt: "+e.getMessage());
        }
        this.moServerNumberLabel.setText("("+mvWorkers.size()+" Server(s))");
        repaint();
        
    }
    
    public void begin(java.util.List waitingPieces) {
        DFracLog.log(3,Name+":begin: starting,"+waitingPieces.size()+" pieces");
        
        mqWaitingPieces = waitingPieces;
        if (!mqWaitingPieces.isEmpty() && !mvWorkers.isEmpty()){
            for (Iterator it=mvWorkers.iterator();it.hasNext();){
                ClAbstractWorkerThread awt=(ClAbstractWorkerThread)it.next();
                if (awt==null) continue;
                awt.beginCalcing();
                
            }
        }
        repaint();
        
    }
    
    public void kill(){
        try{
            stop();
            DFracLog.log(3,Name+":kill: killing workers...");
            for (Iterator it=mvWorkers.iterator();it.hasNext();){
                ClAbstractWorkerThread awt=null;
                try{ awt=(ClAbstractWorkerThread)it.next(); }
                catch(ConcurrentModificationException CME){
                    DFracLog.log(3,Name+":kill:CME catched, breaking...");
                    break;
                }
                if (awt!=null) {
                    awt.interrupt();
                    awt.disConnect();
                }
            }
        }catch(Exception e){ }
    }
    public void stop() {
        
        DFracLog.log(3,Name+":stop: stopping workers...");
        for (Iterator it=mvWorkers.iterator();it.hasNext();){
            ClAbstractWorkerThread awt=null;
            try{ awt=(ClAbstractWorkerThread)it.next(); }
            catch(ConcurrentModificationException CME){
                DFracLog.log(3,Name+":stop:CME catched, breaking...");
                break;
            }
            if (awt!=null) awt.end();
        }
    }
    
    public boolean tick() {
        
        if (mvWorkers.isEmpty()){   //no Workers...
            DFracLog.log(2,Name+":Mainloop: No more workers...");
            return false;
        }
        
        for (Iterator it=mvWorkers.iterator();it.hasNext();){
            ClAbstractWorkerThread awt=null;
            try{ awt=(ClAbstractWorkerThread)it.next(); }
            catch(ConcurrentModificationException CME){
                DFracLog.log(3,Name+":Mainloop:CME catched, breaking...");
                break;
            }
            if (awt==null) continue;
            DFracLog.log(4,Name+":Mainloop:Iterations:"+awt.mnIterations);
            //only update progress and check if its dead...
            if (awt.getProgress() > 0){ awt.updateProgress(); repaint(); }
            if (awt.incIterations() > miPerfListener.getTimeout()){
                //timeout
                DFracLog.log(1,Name+":Mainloop:Timeout for "+awt.getName()+" ("+awt.getPiece()+") hit!");
                reSchedulePieceAndCheck(awt);
                
            }
            
        }       //end for...
        
        return true;
        
    }
    
    public void reSchedulePieceAndCheck(ClAbstractWorkerThread awt){
        awt.end();
        if (awt.getPiece()!=null && !awt.getPiece().isReady()){
            DFracLog.log(3,Name+":reschedule: readd piece("+awt.getPiece()+")");
            synchronized(mqWaitingPieces){
                mqWaitingPieces.add(awt.getPiece());
            }
        }
        
        if(!awt.checkServer()){
            DFracLog.log(1,Name+":reschedule: Server ("+awt.getName()+") dead, trying to restart...");
            if (!awt.reConnect()){
                DFracLog.log(1,Name+":reschedule: Server ("+awt.getName()+") not restarted, removing...");
                remServer(awt);
            }
        }else{
            DFracLog.log(1,Name+":reschedule: Server ("+awt.getName()+") not dead, restarting...");
            if (!mqWaitingPieces.isEmpty())
                awt.beginCalcing();
       }
        
    }
    
    public void calcSucceeded(IFracPiece ifp){
        this.miPerfListener.calcSucceeded(ifp);
    }
    public IFracPiece getNewPiece() {
        return this.miPerfListener.getNewPiece();
    }
    public String getName(){ return Name; }
    
}
