/*
 * ClCorbaStub.java
 *
 * Created on 14. Mai 2004, 11:36
 */

package net;

import Control.*;
import DAL.*;
import util.*;

import org.apache.axis.client.Call;
import org.apache.axis.client.Service;
import javax.xml.namespace.QName;


/**
 *
 * @author  Vitus
 */
public class ClSOAPStub extends ClAbstractWorkerThread{
    private volatile double[] daten;
    private volatile int[] fracpieceCalc;
    private Call moCall;
    private Call moVersionCall;
    
    public boolean connect(String server){
        if (mbConnected){
            disConnect();
            DFracLog.log(2,getName()+":connect: already connected");
        }
        super.connect(server);
        String nPort = "8080";
        int t=0;
        
        if ((t=server.indexOf(':'))>0){
            nPort=server.substring(t+1);
            server=server.substring(0,t);
        }
        
        moCall = null;
        String endpoint =
        "http://"+ server + ":" + nPort + "/axis/DFracSOAPCalculator.jws";
        
        try {
            Service  service = new Service();
            moCall = (Call) service.createCall();
            moVersionCall = (Call) service.createCall();
            
        } catch (Exception e) {
            DFracLog.log(1,getName()+":creating service: "+e.toString());
            return false;
        }
        
        try{
            moCall.setTargetEndpointAddress( new java.net.URL(endpoint) );
            moVersionCall.setTargetEndpointAddress( new java.net.URL(endpoint) );
            moCall.setOperation("calculate");
            moVersionCall.setOperation("getVersion");
        } catch (Exception e) {
            DFracLog.log(1,getName()+":setting Operation: "+e.toString());
            return false;
        }
        
       return checkServer();
    }
    
    public boolean calculate(){
        if (!this.mbConnected) return false;
        daten = new double[10];
        
        daten[0] = (double)ifp.getFracWidth(); // FracWidth
        daten[1] = (double)ifp.getFracHeight(); // FracHeight
        daten[2] = ifp.getFracCenterX(); // CenterX
        daten[3] = ifp.getFracCenterY(); // CenterY
        daten[4] = (double)ifp.getZoom(); // Zoom
        daten[5] = (double)ifp.getNMax(); // NMax
        daten[6] = (double)ifp.getX(); // FracPiece upper left corner X
        daten[7] = (double)ifp.getY(); // FracPiece upper left corner Y
        daten[8] = (double)ifp.getWidth(); // FracPiece Width
        daten[9] = (double)ifp.getHeight(); // FracPiece Height
        fracpieceCalc = new int[ifp.getFracWidth()*ifp.getFracHeight()];
        String ret = "";
        try{
            ret = (String) moCall.invoke( new Object[] { daten } );
            
        } catch (Exception e) {
            DFracLog.log(2,getName()+":calling SOAP Operation failed: "+e.toString());
            return false;
        }
        try{
            String[] ints = ret.split(",");
            for (int i=0;i<ints.length;i++) fracpieceCalc[i] = Integer.parseInt(ints[i]);
        } catch (Exception e) {
            System.err.println("Error splitting and setting ints:"+e.toString());
            return false;
        }
        
        ifp.setPoints(fracpieceCalc);
        return true;
    }
    
    public boolean checkServer(){
        boolean ret=true;
        if (!super.checkServer()) ret=false;
        try{
            this.msVersionString = (String) moVersionCall.invoke( new Object[] {  } );
        }catch(Exception e){
            DFracLog.log(2,getName()+"checkServer: Error getting Version:" + e.getMessage()+", server dead");
            ret=false;
        }
        if (this.msVersionString.equals("")) ret=false;
        this.bAlreadyChecking = false;
        DFracLog.log(3,getName()+"checkServer:server State: "+ret);
        return (mbConnected = ret);
        
    }
}
