/*
 * ClSocketedServerStub.java
 *
 * Created on 14. Mai 2004, 11:34
 */

package net;
import Control.*;
import DAL.*;
import util.*;

import java.net.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
/**
 *
 * @author  Vitus
 */
public class ClSocketedServerStub extends ClAbstractWorkerThread{
    public Socket moSocket=null;
    public ObjectOutputStream moOOS=null;
    public ObjectInputStream moOIS=null;
    
    
    public boolean calculate() {
        if (!mbConnected) return false;
        //write object to stream
        try{
            moOOS.writeObject(ifp);
        }catch(Exception e){
            DFracLog.log(1,getName()+":calcing: piece "+ifp.getNumber()+": Exception while sending data, rescheduling...");
            return false;
        }
        
        //and start main loop ;)
        
        while (this.bRunning && this.mbConnected && !ifp.isReady()){
            DFracLog.log(4,getName()+":calcing: Mainloop");
            
            int nAvail=0;
            try{ Thread.sleep(100); }
            catch(InterruptedException e){ return false; }
            
            try{
                nAvail=moSocket.getInputStream().available();
            }catch(Exception e){
                DFracLog.log(1,getName()+":run:calcing: Error while peeking at data: "+e.getMessage());
                return false;
            }
            
            if (nAvail > 0){
                byte nProg=0;
                try{
                    nProg = (byte) moOIS.readByte();
                }catch(Exception e){
                    DFracLog.log(2,getName()+":run:calcing:Reading byte: "+e.getMessage());
                }
                if (nProg>0){
                    ms8Progress = nProg;
                    DFracLog.log(3,getName()+":run:calcing:Progress update: "+nProg );
                }
                
                if(nAvail > 100){
                    ClFracPiece nFP = null;
                    try{
                        nFP = (ClFracPiece) moOIS.readObject();
                    }catch(Exception e){
                        DFracLog.log(2,getName()+":run:calcing:Reading FracPiece: "+e.getMessage());
                    }
                    
                    DFracLog.log(3,getName()+":run:calcing: got data ..., analyzing...");
                    if (nFP!=null){
                        switch(nFP.mnMode){
                            case IFracPiece.STATE_PONG:
                                break;
                            case IFracPiece.STATE_PING:
                            case IFracPiece.KILL:
                            case IFracPiece.CLOSE:
                                DFracLog.log(2,getName()+":run:calcing: dubios paket, silently ignored...");
                                break;
                            case IFracPiece.STOP:
                                DFracLog.log(3,getName()+":run:calcing: got calc'ed FracPiece, analyzing...");
                                if (nFP.isReady())  ifp=nFP;
                                else{
                                    DFracLog.log(1,getName()+":run:calcing: Error, piece not ready, discarding & rescheduling");
                                    moStatusLabel.setText("[error]");
                                    return false;
                                }
                                break;
                            case IFracPiece.CALC:
                                //updated status:
                                DFracLog.log(3,getName()+":run:calcing: new Progress:"+nFP.getProgress());
                                ms8Progress = nFP.getProgress();
                                break;
                        }//end switch
                    }//end nfp!=null
                }//end if avail>100
            }//end avail>0
        }//end while (!bReady)
        return true;
        
    }
    
    public boolean connect(String server) {
        if (mbConnected){
            disConnect();
            DFracLog.log(2,getName()+":connect: already connected,disconnecting...");
        }
        super.connect(server);
        int nPort = 24567;
        int t=0;
        
        if ((t=server.indexOf(':'))>0){
            nPort=Integer.parseInt(server.substring(t+1));
            server=server.substring(0,t);
        }
        try{
            DFracLog.log(3,getName()+":connect: connecting to "+server+":"+nPort);
            moSocket = new Socket(server,nPort);
            DFracLog.log(3,getName()+":connect: Socket connected, setting up outputstream");
            moOOS = new ObjectOutputStream(moSocket.getOutputStream());
            
        }catch(Exception e){
            DFracLog.log(1,getName()+":connect: Error Connecting, server not added...");
            try{ moSocket.close();}catch(Exception e7){}
            return false;
        }
        
        try{
            DFracLog.log(3,getName()+":connect: sending state request packet...");
            moOOS.writeObject(new ClFracPiece());
        }catch(Exception e){
            DFracLog.log(1,getName()+":connect: Error sending, server not added...");
            try{ moSocket.close();}catch(Exception e6){}
            return false;
        }
        
        DFracLog.log(3,getName()+":connect: sent... reading response...");
        try{ Thread.sleep(500);}catch(Exception e1){}
        
        ClFracPiece nFP=null;
        
        try{
            if (moSocket.getInputStream().available() < 4){
                DFracLog.log(1,getName()+":connect: not enough data, server not added");
                try{ moSocket.close();}catch(Exception e2){}
                return false;
            }
            moOIS = new ObjectInputStream(moSocket.getInputStream());
            nFP = (ClFracPiece) moOIS.readObject();
        }catch(Exception e){
            DFracLog.log(1,getName()+":connect: Error reading, server not added");
            try{ moSocket.close();}catch(Exception e2){}
            return false;
        }
        
        
        if (nFP==null){
            DFracLog.log(1,getName()+":connect: nothing read, server not added");
            try{ moSocket.close();}catch(Exception e3){}
            return false;
        }
        DFracLog.log(3,getName()+":connect: response ok, adding server: "+server+":"+nPort);
        
        return checkServer();
        
    }
    
    public void end(){
        if (!bRunning) return;
        bRunning=false;
        DFracLog.log(3,getName()+":end: stopping Server...");
        try{
            moOOS.writeObject(new ClFracPiece(IFracPiece.STOP));
            moStatusLabel.setText("[ready]");
            
        }catch(Exception e){
            DFracLog.log(1,getName()+":end: error stopping server");
            if (!checkServer()){
                DFracLog.log(1,getName()+"checked server, dead, removing...");
                this.moAcp.remServer(this);
            }
        }
    }
    public void disConnect(){
        end();
        if (!mbConnected) return;
        DFracLog.log(3,getName()+":disconnect: Closing Socket...");
        try{
            moStatusLabel.setText("[closing]");
            moOOS.writeObject(new ClFracPiece(IFracPiece.CLOSE));
            moSocket.close();
            
        }catch(Exception e){
            DFracLog.log(1,getName()+":disconnect: error Closing connxion: "+e.getMessage());
        }
        mbConnected=false;
    }
    public boolean checkServer(){
        boolean ret=true;
        if (!super.checkServer()) ret=false;
        
        ClFracPiece nFP = null;
        try{
            DFracLog.log(3,getName()+":checkServer: sending state request packet...");
            moOOS.writeObject(new ClFracPiece());
        }catch(Exception e){
            DFracLog.log(1,getName()+":checkServer: Error sending, server dead...");
            ret=false;
        }
        
        
        if (ret){
            DFracLog.log(3,getName()+":checkServer: sent... reading response...");
            try{ Thread.sleep(200);}
            catch(InterruptedException ex){ ret=false; }
            catch(Exception e){}
            try{
                if (moSocket.getInputStream().available() < 10){
                    DFracLog.log(1,getName()+":checkServer: not enough data, server dead...");
                    try{ moSocket.close();}catch(Exception e2){}
                    ret=false;
                }
                nFP = (ClFracPiece) moOIS.readObject();
            }catch(Exception e){
                DFracLog.log(1,getName()+":checkServer: Error reading, server dead...");
                ret=false;
            }
        }
        
        if (nFP==null) ret=false;
        else{
            DFracLog.log(3,getName()+":checkServer: X: "+nFP.getX());
            this.msVersionString = nFP.getX()+"."+nFP.getY() ;
            if (this.msVersionString.equals(".")) ret=false;
        }
        this.bAlreadyChecking = false;
        
        DFracLog.log(3,getName()+":checkServer: serverstate: "+ret);
        return (mbConnected = ret);
    }
    
    
}


