import java.io.*;
import org.omg.CORBA.*;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
import DFracCorba.*;

public class runCorbaServer {
    public static void main(String args[]){
        ORB orb = ORB.init(args, null);
        try{
            org.omg.PortableServer.POA poa = org.omg.PortableServer.POAHelper.narrow(
                orb.resolve_initial_references("RootPOA"));
            poa.the_POAManager().activate();
            DFracCorbaCalculator dfc = new DFracCorbaCalculator();
            dfc.setORB(orb);
            org.omg.CORBA.Object ref = poa.servant_to_reference(dfc);
            CorbaDFracServer dfcref = CorbaDFracServerHelper.narrow(ref);
            // get the root naming context
            org.omg.CORBA.Object objRef = orb.resolve_initial_references("NameService");
            
            NamingContextExt ncRef = NamingContextExtHelper.narrow(objRef);
            
            // bind the Object Reference in Naming
            String name = "DFracCalculator";
            NameComponent path[] = ncRef.to_name( name );
            ncRef.rebind(path, dfcref);
            System.out.println("DFracCorbaServer ready and waiting ...");
            orb.run();
        }
        catch(Exception e){
            e.printStackTrace();
        }
        orb.run();
    }
}
