/** Start up class for the server.
 *  Only parses the commandline and startes server.
 *
 */

import java.util.*;

public abstract class runSocketServer{
    /** Help String */
    private static final String mstrHelp =
    "Usage: java runSocketServer [options]\n\n"+
    "where options include:-h,--help\tdisplays this help\n-p (port)\tsets the port";

    /** main method to start the application
     *  @param args - String Array with arguments */
    public static void main(String[] args) {
        int i=0,port=0;

        if (args.length > 0){
            for (i=0;i<args.length;i++){
                if (args[i].equals("-l")){
                    util.DFracLog.setLogLevel(Integer.parseInt(args[i+1]));
                    i++;
                }
                else if (args[i].equals("-p")){
                    port=Integer.parseInt(args[i+1]);
                    i++;
                }
            }
            
            Arrays.sort(args);
            if ( (Arrays.binarySearch(args,"-h")>=0) ||
            (Arrays.binarySearch(args,"--help")) >=0 ){
                System.out.println(mstrHelp);
                System.exit(0);
            }

        } else util.DFracLog.setLogLevel(1);
        //start the app
            
        net.DFracSocketedServer dfrac_server = new net.DFracSocketedServer(port);
        util.DFracLog.log(1,"exiting SocketedServer");
    }
}
